﻿var myCornerRadius;
var myCornerOptionsIndex;
main();
function main()
{

	if (app.documents.length == 0) 
	{
		alert ("Документ не открыт. Откройте вначале документ");
		return;
	}
	if(app.selection.length > 0)
	{
			if(app.selection[0].constructor.name == "Table" )
			{
                    if( myDialog()  ) {
                        myTest(app.selection[0]);
                        roundedTable(app.selection[0]);
                    }
			}
			else
			{
				alert("Нужно выделить таблицу в текстовом режиме");
				return;
			}
		}
	else 
		{
		alert("Выделите таблицу в текстовом режиме и запустите скрипт снова");
		return;
		}

} // main()

function myDialog()
{
    var myDialog = app.dialogs.add({name:"Corner Options"});
    with(myDialog){
        with(dialogColumns.add()){
            with(borderPanels.add()){
                with(dialogRows.add()){
                    with(dialogColumns.add()){
                        staticTexts.add({staticLabel:"Effect:"});
                     }
                    with(dialogColumns.add()){
                        var myEffectsMenu = dropdowns.add({stringList:["None", "Fancy", "Bevel", "Inset", "Inverce Rounded","Rounded"], selectedIndex:0});
                     }
               } // with(dialogRows.add()){
                with(dialogRows.add()){
                    with(dialogColumns.add()){
                        staticTexts.add({staticLabel:"Point Size:"});
                    }
                    with(dialogColumns.add()){
                        var myPointSizeField = realEditboxes.add({editValue:10});
                    }
                } //with(dialogRows.add()){
                
            } // borderpanel
        } // with(dialogColumns
    } // with(myDialog)
// конец диалога
        if (  !myDialog.show()  ) 
        {
           myDialog.destroy();  
            return false;
        }
myCornerRadius = myPointSizeField.editValue;     
myCornerOptionsIndex = myEffectsMenu.selectedIndex;
myDialog.destroy(); 
return true;
}  // fnc

function roundedTable(myTable)
{
var myDocument = app.activeDocument
with (myDocument.viewPreferences){
	// Сохраняем старые единицы измерения в переменных OldXUnits, myOldYUnits
	var myOldXUnits = horizontalMeasurementUnits;
	var myOldYUnits = verticalMeasurementUnits;
	// Устанавливаем новые единицы измерения
	horizontalMeasurementUnits = MeasurementUnits.points;
	verticalMeasurementUnits = MeasurementUnits.points;
}

//----------------------------------------------------------
// Основной код скрипта
//----------------------------------------------------------
	var myH = myTable.height;
	var myW = myTable.width;
	var myStrokeWeight = myTable.topBorderStrokeWeight;
    //var myStrokeColor = myTable.topBorderStrokeColor;
    //alert(myStrokeColor.name);
	var myTextFrame = myTable.parent;
	var myParagraphs =myTextFrame.paragraphs;

	if((myTextFrame.geometricBounds[3] - myTextFrame.geometricBounds[1] ) >= myW || (myTextFrame.geometricBounds[2] - myTextFrame.geometricBounds[0] ) >= myH)
	{
        DelTableEdge(myTable);
        for (var i=0; i< myParagraphs.length; i++)
			{
				if(myParagraphs[i].tables[0] == myTable)
				{
					var myTablePara =myParagraphs[i]; 
					break;
				}
			} // for
        
       var myPrevPara = myParagraphs[i-1];
       myTablePara.leading = 0;
// Вставляем текстовый фрейм    ****************   
       var myBorder = myPrevPara.insertionPoints[-1].rectangles.add();
// Задаем свойства вставленного фрейма
        var myNoneSwatch = app.activeDocument.swatches.item("None");
        myBorder.fillColor    = myNoneSwatch;
        //myBorder.strokeColor= myStrokeColor;
        myBorder.strokeWeight = myStrokeWeight;
// Задаем параметры привязки
        with(myBorder.anchoredObjectSettings)
        {
                anchoredPosition = AnchorPosition.anchored;
                anchorPoint = AnchorPoint.TOP_LEFT_ANCHOR
                horizontalReferencePoint = AnchoredRelativeTo.anchorLocation;
                horizontalAlignment = HorizontalAlignment.leftAlign;
                anchorXoffset = myTablePara.firstLineIndent;
                verticalReferencePoint = VerticallyRelativeTo.lineBaseline;
                anchorYoffset = myTable.spaceBefore; 
                anchorSpaceAbove = 0;
        }
// Тип закругления углов         
         switch (myCornerOptionsIndex)
         {
                case 0:
                    myBorder.cornerOption = CornerOptions.NONE;
                break;
                case 1:
                    myBorder.cornerOption = CornerOptions.FANCY_CORNER;
                break;
                case 2:
                    myBorder.cornerOption = CornerOptions.BEVEL_CORNER;
                break;
                case 3:
                    myBorder.cornerOption = CornerOptions.INSET_CORNER;
                break;
                case 4:
                    myBorder.cornerOption = CornerOptions.INVERSE_ROUNDED_CORNER;
                break; 
                case 5:
                    myBorder.cornerOption = CornerOptions.ROUNDED_CORNER;
                break;                  
          } //switch
// Радиус
         myBorder.cornerRadius = myCornerRadius;
         myBorder.strokeColor = app.activeDocument.swatches.item("Black");
		
		
        var myTextFrameGB = myTextFrame.geometricBounds;
        var anchorGB = myBorder.geometricBounds;
        anchorGB[2] = anchorGB[0] + myH;
        anchorGB[3] = anchorGB[1] + myW;
        switch(myTablePara.justification)
        {
            case Justification.LEFT_ALIGN:
            case Justification.LEFT_JUSTIFIED:
            case Justification.FULLY_JUSTIFIED:
            break;
            case Justification.CENTER_ALIGN:
            case Justification.CENTER_JUSTIFIED:
                myBorder.anchoredObjectSettings.anchorPoint = AnchorPoint.TOP_CENTER_ANCHOR;
                myBorder.anchoredObjectSettings.horizontalAlignment = HorizontalAlignment.centerAlign;
            break;
            case Justification.RIGHT_ALIGN:
                myBorder.anchoredObjectSettings.anchorPoint = AnchorPoint.TOP_RIGHT_ANCHOR;
                myBorder.anchoredObjectSettings.horizontalAlignment = HorizontalAlignment.rightAlign;                
            break;
            default:
            break;
         } // switch
        
		myBorder.geometricBounds = anchorGB;
	}
	else
	{
		alert("Размер таблицы больше размера текстового фрейма. Продолжение невозможно");
		exit();
	}


// Возвращаем Индизайну старые единицы измерения
        with (myDocument.viewPreferences){
            try{
                horizontalMeasurementUnits = myOldXUnits;
                verticalMeasurementUnits = myOldYUnits;
            }
            catch(myError){
                alert("Could not reset custom measurement units.");
            }
        } /// with
}// fnc


function DelTableEdge(myTable)
{
     myTable.bottomBorderStrokeWeight = myTable.topBorderStrokeWeight = 0;
    myTable.leftBorderStrokeWeight = myTable.rightBorderStrokeWeight = 0;
    var myRows = myTable.rows;
    var myNRows = myRows.length
    var myFirstRow = myRows[0];
    var myLastRow = myRows[myNRows-1];
    
     var myColumns = myTable.columns;
     var myNColumns = myColumns.length;
     var myFirstColumn = myColumns[0];
     var myLastColumn = myColumns[myNColumns-1];
 // Верх и низ     
    for (var r = 0; r < myNColumns; r++)
    {
         try {
                myFirstRow.cells[r].topEdgeStrokeWeight = 0;
                myLastRow.cells[r].bottomEdgeStrokeWeight = 0;
                }
        catch(_) {}
     }
 // Левая и правая сторона
     for (var c = 0; c < myNRows; c++)
     {
         try {
                 myFirstColumn.cells[c].leftEdgeStrokeWeight = 0;
                 myLastColumn.cells[c].rightEdgeStrokeWeight = 0;
                }
            catch(_) {}
     }   
} // fnc

function myTest(myTable)
// Проверка, находится ли таблица в первом абзаце текстового фрейма
{
    var myTextFrame = myTable.parent;
	var myParagraphs =myTextFrame.paragraphs;
    for (var i=0; i< myParagraphs.length; i++)
			{
				if(myParagraphs[i].tables[0] == myTable)
				{
					var myTablePara =myParagraphs[i]; 
					break;
				}
			} // for
    if(!i)
    {
        myParagraphs[0].insertionPoints[0].contents ="\r";
        myTextFrame.recompose;
    }
    
} // 